<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Wartung" (Maintenance)                               |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version: 4.1 / March 2015

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 
$translator->addTranslation('maintenance', CPO_BASEDIR.$moduleDirectory.'/lang');

// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen)************
if (isset($_POST['go'])) {
	$new_settings = $_POST;
    foreach ($activeModules['Maintenance'] as $k=>$v) {
        if (!isset($_POST['cpoMaintenanceNew'][$k])) continue;
        if (is_bool($activeModules['Maintenance'][$k])) {
            $activeModules['Maintenance'][$k] = (bool) $_POST['cpoMaintenanceNew'][$k];
        } else {
			$activeModules['Maintenance'][$k] = $_POST['cpoMaintenanceNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpoMaintenanceNew'])) unset($new_settings['cpoMaintenanceNew'][$k]);
    }
    foreach ($new_settings['cpoMaintenanceNew'] as $k=>$v) {
		$activeModules['Maintenance'][$k] = $new_settings['cpoMaintenanceNew'][$k];
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = '%s'", 
            addslashes(serialize($activeModules['Maintenance'])),
			'Maintenance'
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = __('Module settings were updated!');
}

require(CPO_BASEDIR.'_include/header.php');

?>
<script type="text/javascript"><!--

function textarea (boxid, link){ 
	var t=document.getElementById(boxid); 
	if(link.innerHTML=='<?php echo __('enlarge'); ?>'){ 
		t.style.height = t.offsetHeight+250+"px"; 
		link.innerHTML='<?php echo __('reduce'); ?>'; 
	} else{ 
		t.style.height = t.offsetHeight-250+"px"; 
		link.innerHTML='<?php echo __('enlarge'); ?>'; 
	} 
} 


//--> </script>

<?php

printPageHeader(
    __('Maintenance'),
    __('In this view you can work on the maintenance settings.')
);
include(CPO_BASEDIR.'_include/message.php');
include('./producer.inc.php');

if(array_key_exists('Maintenance', $activeModules))  {
	// table header {{{
	echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="modulesettings">';
	echo '<input type="hidden" name="go" value="1">';
	echo '<table class="colored" style="width: 100%;">';
	echo '<thead><tr>';

	echo '<th colspan="2"><span>'.__('Maintenance settings').'</span></th>';

	echo '</tr></thead><tbody>';
	// }}}

	echo '<tr>';
		echo '<td class="leftrow">';
		echo __('Maintenance page:');
		echo '</td>';
		echo '<td class="rightrow">';
        echo '<input type="text" class="text inputwidth" name="cpoMaintenanceNew[page]" value="'.$activeModules['Maintenance']['page'].'" maxlength="255"><br/>'.__('leave empty to use the html-code below');
		echo '</td>';
	echo '</tr>';
    if (version_compare($CPO['version'], '4.1.0') >= 0) {
        echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Page-Template:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<select name="cpoMaintenanceNew[pagetemplate_index]" size="1">';
            echo '<option value="0"'
                .($activeModules['Maintenance']['pagetemplate_index']==0 ? ' selected' : '')
                .'>--- '.___('Use header and footer files').' ---</option>';
            $query = 'SELECT id, name FROM '.CPO_PAGETEMPLATES.' '
                    .'ORDER BY name';
            $db->query($query);
            $_pagetemplates = array();
            while ($db->next_record()) {
                $_pagetemplates[$db->v('id')] = $db->v('name');
            }
            foreach ($_pagetemplates as $k=>$v) {
                echo '<option value="'.htmlspecialchars($k, ENT_COMPAT, 'ISO-8859-15').'"'
                    .($activeModules['Maintenance']['pagetemplate_index']==$k ? ' selected' : '')
                    .'>'.htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15').'</option>';
            }
            echo '</select>';
            echo '</td>';
        echo '</tr>';
    }
    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Custom HTML code:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<textarea style="width: 95%; height: 100px;" class="text inputwidth" name="cpoMaintenanceNew[html_code]" id="html_code">'.$activeModules['Maintenance']['html_code'].'</textarea>';
        echo '<br /><a href="#" onClick="textarea(\'html_code\', this);return false" id="lnk">'.__('enlarge').'</a>';
        echo '</td>';
    echo '</tr>';
	echo '<tr>';
		echo '<td class="leftrow">';
		echo __('Turn on maintenance mode:');
		echo '</td>';
		echo '<td class="rightrow">';
			echo '<select name="cpoMaintenanceNew[state]" size="1">';
			$selon = ($activeModules['Maintenance']['state']=="on") ? ' selected="selected"' :'';
			$seloff = ($activeModules['Maintenance']['state']=="off") ? ' selected="selected"' :'';
			echo '<option value="on"'.$selon.'>'.__('on').'</option>';
			echo '<option value="off"'.$seloff.'>'.__('off').'</option>';
			echo '</select>';
		echo '</td>';
	echo '</tr>';
	echo '<tr>';
		echo '<td class="leftrow">';
		echo __('Debug level:');
		echo '</td>';
		echo '<td class="rightrow">';
			echo '<select name="cpoMaintenanceNew[varDEBUG]" size="1">';
			$seloff = ($activeModules['Maintenance']['varDEBUG']==0) ? ' selected="selected"' :'';
			$sel_runtime = ($activeModules['Maintenance']['varDEBUG']=='runtime') ? ' selected="selected"' :'';
			$sel_1 = ($activeModules['Maintenance']['varDEBUG']==1) ? ' selected="selected"' :'';
			$sel_2 = ($activeModules['Maintenance']['varDEBUG']==2) ? ' selected="selected"' :'';
			$sel_3 = ($activeModules['Maintenance']['varDEBUG']==3) ? ' selected="selected"' :'';
			$sel_4 = ($activeModules['Maintenance']['varDEBUG']==4) ? ' selected="selected"' :'';
			echo '<option value="0"'.$seloff.'>'.__('off').'</option>';
			echo '<option value="runtime"'.$sel_runtime.'>'.__('runtime').'</option>';
			echo '<option value="1"'.$sel_1.'>'.__('1 (low)').'</option>';
			echo '<option value="2"'.$sel_2.'>'.__('2 (medium)').'</option>';
			echo '<option value="3"'.$sel_3.'>'.__('3 (high)').'</option>';
			echo '<option value="4"'.$sel_4.'>'.__('4 (full)').'</option>';
			echo '</select><br/>'.__('the kind of information shown on each level depends on the programmer\'s decision, so don\'t worry if you see no difference!');
		echo '</td>';
	echo '</tr>';

	echo '<tr>';
		echo '<td class="leftrow">';
		echo '&nbsp;';
		echo '</td>';
		echo '<td class="rightrow">';
		echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
		echo '</td>';
	echo '</tr>';
	echo '</tbody></table>';

	echo '</form>';

}
require(CPO_BASEDIR.'_include/footer.php');
?>
